// DTimeUITestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DTimeUITest.h"
#include "DTimeUITestDlg.h"
#include "DTime+UI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDTimeUITestDlg dialog

CDTimeUITestDlg::CDTimeUITestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDTimeUITestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDTimeUITestDlg)
	//}}AFX_DATA_INIT

	m_Date = DTimePlus::CDate<DTimePlus::CGregorianCalendar>::CurrentLocalDate();
	m_TimeSpan = DTimePlus::CLTimeOfDay<>::CurrentLocalTime();

	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDTimeUITestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDTimeUITestDlg)
	//}}AFX_DATA_MAP

	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER1, m_Date);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER2, m_TimeSpan);
}

BEGIN_MESSAGE_MAP(CDTimeUITestDlg, CDialog)
	//{{AFX_MSG_MAP(CDTimeUITestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDTimeUITestDlg message handlers

BOOL CDTimeUITestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDTimeUITestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDTimeUITestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
